-----------------------------------------------------------------------------------------------
-- Client Lua Script for VisceralusHelper
-- Copyright (c) NCsoft. All rights reserved
-- 
-------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- VisceralusHelper Module Definition
-----------------------------------------------------------------------------------------------
local VisceralusHelper = {} 
local version = 16
local sin = math.sin
local cos =  math.cos
local rad = math.rad

local ktCommonFirstNameTitles = {"Engineer", "Doctor", "Medic", "Spellslinger", "Warrior", "Esper", "Stalker", "Captain", "Hung", "Brother", "Mr", "Not","Mister","Miss" }
	
	local colors = {}
	colors[1] ="ff00ff00"
	colors[2] ="ff00ff00"
	colors[3] ="ff00ff00"
	colors[4] ="ff00ff00"
	colors[5] ="ffffff80"
	colors[6] ="ffffff80"
	colors[7] ="ffffff80"

local LocalesNames = {
	["Visceralus"] = {
		[1] = "Visceralus",
		[2] = "Visceralus",
		[3] = "Visceralus",
		[99] = "Raid Target Dummy",  --For Testing
	},
	["Blinding Light"] = {
		[1] = "Blinding Light",
		[2] = "Blinding Light",
		[3] = "Blinding Light",
		[99] = "Blade Dance",
	},
}




----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function VisceralusHelper:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function VisceralusHelper:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- VisceralusHelper OnLoad
-----------------------------------------------------------------------------------------------
function VisceralusHelper:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("VisceralusHelper.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- VisceralusHelper OnDocLoaded
-----------------------------------------------------------------------------------------------
function VisceralusHelper:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.Overlay = Apollo.LoadForm(self.xmlDoc, "Overlay", "InWorldHudStratum", self)
--	    self.PopUp = Apollo.LoadForm(self.xmlDoc, "OHPopUp", nil, self)
		if self.Overlay == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
--	    self.PopUp:Show(false, true)
	    self.Overlay:Show(true)

		Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)

		self.lineWidth = 4
		self.lineLength = 31
		
		self.watchList = {}
		self.buffFrequency = 0.5
		self.KSlider = 10
		self.Resolution = 5
		-- Locale Check
		local strCancel = Apollo.GetString(1)
		if strCancel == "Abbrechen" then
			self.Locale = 2
		elseif strCancel == "Annuler" then
			self.Locale = 3
		else
			self.Locale = 1
		end
		self.theRoots = {}
		self.theTwirls = {}
		self.hasRoot=false	
		self.hasTwirl=false	
		self.player = GameLib.GetPlayerUnit()
	end
end

---------------------------------------------------------

-----------------------------------------------------------------------------------------------
-- VisceralusHelper Instance
-----------------------------------------------------------------------------------------------
local VisceralusHelperInst = VisceralusHelper:new()
VisceralusHelperInst:Init()


function VisceralusHelper:OnNextFrame()
	self.player = GameLib.GetPlayerUnit()
	
	if self.player == nil then return end
	
	self.Overlay:DestroyAllPixies()
	
	self:DrawRoots()

	
	if not self.player:IsInCombat() then
	  Apollo.RemoveEventHandler("NextFrame",self)
		Apollo.RemoveEventHandler("VarChange_FrameCount", self)
			self.Overlay:DestroyAllPixies()
		self.btimer = nil
		self.watchList = nil 
		self.watchList = {}
		return
	end

	for k, v in pairs(self.watchList) do
		self:SetupLines(v)
	end
end

function VisceralusHelper:OnFrame()
	--self:GetRoots()
end


function VisceralusHelper:DrawRoots()
	local blank = {0,0,0}
	for i = 1, #self.theRoots do
		if self.theRoots[i]:IsValid() then
			local playerpos = self.theRoots[i]:GetPosition() or blank
			local pvec = Vector3.New(playerpos.x, playerpos.y, playerpos.z)
			local lPos = GameLib.WorldLocToScreenPoint(pvec)
			local text = self:GetFirstName(self.theRoots[i])
			self.Overlay:AddPixie( {
				strText = text, strFont = "CRB_FloaterLarge", crText = "ffffffff",
				loc = { fPoints = {0,0,0,0}, nOffsets = { lPos.x-200, lPos.y-80, lPos.x+200, lPos.y+60} },
				flagsText = { DT_VCENTER = true,DT_CENTER = true, DT_WORDBREAK = true }
			} )
	   end
	end
end

function VisceralusHelper:GetRoots()
	self.theRoots = {}
    for i = 1, GroupLib.GetMemberCount(), 1 do

		local member = GroupLib.GetUnitForGroupMember(i)
		
		if member and not member:IsDead() then
			self:HasDebuff(member)
		end
	end			
end

function VisceralusHelper:OnDeBuffApplied(unitName, splId, unit)
	if splId == 73179 or splId == 73177 then
		table.insert(self.theRoots, unit)
	end
end

function VisceralusHelper:HasDebuff(unit)
	local tBuffs = unit:GetBuffs().arHarmful
	if not tBuffs then return end
	for k, v in pairs(tBuffs) do
		local spellname = v.splEffect:GetName()
	    if  spellname == "Primal Entanglement" then
			table.insert(self.theRoots, unit)
	    elseif  spellname == "Twirl" then
			table.insert(self.theRoots, unit)
		end
	end

end


function VisceralusHelper:OnEnteredCombat(unit, bInCombat)
	if unit and unit:GetType() ~= "NonPlayer" then return end
	local uName = unit:GetName()
	if uName == self:GetLocaleName("Visceralus") then
		Apollo.RegisterEventHandler("VarChange_FrameCount", "OnFrame", self)
		Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
		self.btimer = ApolloTimer.Create(self.buffFrequency, true, "GetRoots", self)
		self:CheckWatchList(unit)
	end
end

function VisceralusHelper:OnBuffTimer()
end

function VisceralusHelper:GetLocaleName(name)
	--self.Locale = 99 -- For Testing

	if LocalesNames[name] ~= nil then
		return LocalesNames[name][self.Locale]
	end
	return "Invalid Name"
end




function VisceralusHelper:CheckWatchList(unit)
	if not self.watchList[unit:GetId()] then
		self.watchList[unit:GetId()] = unit
	end
end


function VisceralusHelper:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	local tsave = {}
	tsave.KSlider = self.KSlider
	return tsave
end


function VisceralusHelper:OnRestore(eLevel, saveData)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	for k,v in pairs(saveData) do
	   	self[k]=v
	end
end



-- Line Plotting
function VisceralusHelper:SetupLines(targ)
	if targ:IsDead() or not targ:IsValid() then
	return
	end
	
	local alpha = "90"
	local tface = targ:GetFacing()
	local targ_screen_pos = GameLib.GetUnitScreenPosition(targ)

	local tangle = math.atan2(tface.x, tface.z)
	local frontColor = "50ffff00"
	local sideColor = "500000ff"
	local sizeMod = 1

	
	if targ:IsCasting() then
		local spell = targ:GetCastName()
		if spell == self:GetLocaleName("Blinding Light") then
			frontColor ="90ff0000"
			sideColor ="90ff0000"
			sizeMod = 3
			
			local nDuration = targ:GetCastDuration()
			local nElapsed = targ:GetCastElapsed()
			local delay = 1400
			nElapsed = nElapsed 
		
			if nElapsed > delay then
				local degree = 121 * (nElapsed-(delay)) / (nDuration-(delay))
				tangle = tangle + rad(degree)
			end
		end
	end
	
	
	local leftV = tangle + rad(72)
	local leftV2 = tangle + rad(144)
	local rightV = tangle + rad(-72)
	local rightV2 = tangle + rad(-144)

	local tpos = targ:GetPosition()
	local tposV = Vector3.New(tpos.x,tpos.y,tpos.z)
	
		
	local dist = self.lineLength
    local frontEnd = Vector3.New(tposV.x+dist*sin(tangle), tposV.y, tposV.z+dist*cos(tangle))
	local frontOffset = Vector3.InterpolateLinear(frontEnd, tposV, 0.90)

	self:DrawLine(frontEnd, frontOffset, frontColor,sizeMod)

	local leftEnd = Vector3.New(tposV.x+dist*sin(leftV), tposV.y, tposV.z+dist*cos(leftV))
	local leftOffset = Vector3.InterpolateLinear(leftEnd, tposV, 0.90)
	self:DrawLine(leftEnd, leftOffset, sideColor,sizeMod)

	local leftEnd2 = Vector3.New(tposV.x+dist*sin(leftV2), tposV.y, tposV.z+dist*cos(leftV2))
	local leftOffset2 = Vector3.InterpolateLinear(leftEnd2, tposV, 0.90)
	self:DrawLine(leftEnd2, leftOffset2, sideColor,sizeMod)
	
	local rightEnd = Vector3.New(tposV.x+dist*sin(rightV), tposV.y, tposV.z+dist*cos(rightV))
	local rightOffset = Vector3.InterpolateLinear(rightEnd, tposV, 0.90)
	self:DrawLine(rightEnd, rightOffset, sideColor,sizeMod)
	
	local rightEnd2 = Vector3.New(tposV.x+dist*sin(rightV2), tposV.y, tposV.z+dist*cos(rightV2))
	local rightOffset2 = Vector3.InterpolateLinear(rightEnd2, tposV, 0.90)
	self:DrawLine(rightEnd2, rightOffset2, sideColor,sizeMod)
end

--Line Drawing
function VisceralusHelper:DrawLine(startV, endV, col, sizeMod)
	local startPoint = GameLib.WorldLocToScreenPoint(startV)
	local endPoint = GameLib.WorldLocToScreenPoint(endV)
	local thick = self.KSlider or 8
	self.Overlay:AddPixie( { bLine = true, fWidth = thick*sizeMod, cr = col, loc = { fPoints = { 0, 0, 0, 0 }, nOffsets = { startPoint.x, startPoint.y, endPoint.x, endPoint.y } } })
end




function VisceralusHelper:GetFirstName(unit)
	local strName = unit:GetName()
	local loopnum = 0
	local invalidName = false
	local firstName = ""
	local secondName = ""	

	if unit:GetType() == "Player" then
		if string.len(strName) > 12 then
			for i in string.gmatch(strName, "%S+") do
				loopnum=loopnum+1
				if loopnum == 1 then
					firstName = i
				else
					secondName = i
				end
			end
		
			for t=1, #ktCommonFirstNameTitles do
				if ktCommonFirstNameTitles[t] == firstName then
					invalidName = true
				end
			end
			
			if invalidName then 
				return secondName
			else
				return firstName
			end
		end
	end
	return strName
end
